<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { storeToRefs } from 'pinia';
import { useI18n } from 'vue-i18n';
import { ref, inject } from 'vue';
import { adminMenuEnum, paneTypes } from '@/enums/enums';
import { useMetaStore } from '@/stores/meta';
import RightEntry from "./AdminMenuRightEntry.vue";
import DropdownItem from "./NavDropdownItem.vue";
import Accordion from "./NavAccordion.vue";
import { userType } from '@/enums/enums';
import Dropdown from "@/components/general/Dropdown.vue";
import Button from "@/components/general/Button.vue";


const { t } = useI18n();
const $t = t;

const props = defineProps<{
    free?: boolean,
}>();

const meta = useMetaStore();
const { paneType, noPassHash, userType: getUserType, getCommentsAllowed, openMenu } = storeToRefs(meta);

let configuration = inject<any>('configuration');

const showQRCodeModal = (close: () => void) => {
    close();
    openMenu.value = adminMenuEnum.QRCODE;
}

const showPasswordResetModal = (close: () => void) => {
    close();
    openMenu.value = adminMenuEnum.PASSWORDRESET;
}

const showDeletePaneModal = (close: () => void) => {
    close();
    openMenu.value = adminMenuEnum.DELETE;
}

const getExportURL = ref(configuration!.basePath + `dl?panetype=${(paneType.value === paneTypes.SCHEDULE || paneType.value === paneTypes.STREAM ? "s" : paneType.value === paneTypes.FREEFORM ? "f" : "t")}&paneid=${noPassHash.value}&type=png`);

const openExportImage = (close: () => void) => {
    close();
    window.open(getExportURL.value, '_blank')?.focus();
}

const showPDFExportModal = (close: () => void) => {
    close();
    openMenu.value = adminMenuEnum.EXPORTPDF;
}

const showCopyForMeModal = (close: () => void) => {
    close();
    openMenu.value = adminMenuEnum.COPY;
}

const showShareModal = (close: () => void) => {
    close();
    openMenu.value = adminMenuEnum.SHARE;
}

const showAdministrationSidebar = (close: () => void) => {
    close();
    openMenu.value = adminMenuEnum.SETTINGS;
}

</script>
<template>
    <Dropdown placement="bottom-end" width="min-w-[420px]"
        v-if="getUserType === userType.ADMIN || getUserType === userType.MODERATOR">
        <template #button>
            <Tooltip :tooltip="$t('adminMenu.burgermenu')">
                <button class="size-12 hover:bg-gray-200 text-gray-500 rounded-md block text-center align-middle leading-[48px] text-2xl hover:no-underline" v-if="!free">
                    <i class="ri-menu-line leading-12 align-middle"></i>
                </button>
                <Button variant="white" v-else>
                    <i class="ri-menu-line ri-lg -ml-0.5 leading-10 align-middle"></i>
                </Button>
            </Tooltip>
        </template>
        <template v-slot="{ close }">
            <div class="flex flex-row gap-2">
                <div class="max-w-64 min-w-64 p-4">
                    <div class="w-full">
                        <strong class="">{{ $t("adminMenu.lockStates.label") }}</strong>
                    </div>
                    <RightEntry type="delete" />
                    <RightEntry type="move" />
                    <RightEntry type="editHeader" v-if="paneType === paneTypes.SCHEDULE" />
                    <RightEntry type="commentable" v-if="getCommentsAllowed" />
                    <RightEntry type="all" />
                </div>
                <div class="border-r-2 border-gray-300 my-8"></div>
                <div class="max-w-64 min-w-64 p-4">
                    <strong>{{ $t("adminMenu.actions") }}</strong>
                    <DropdownItem icon="share" @click="showQRCodeModal(close)" color="text-orange-500"
                        :label="$t('adminMenu.pageShare.label')" />
                    <DropdownItem @click="() => showAdministrationSidebar(close)" icon="pencil"
                        color="text-blue-500" :label="$t('adminMenu.adjustPaneLabel')" />
                    <DropdownItem @click="showPasswordResetModal(close)" icon="key" color="text-emerald-500"
                        :label="$t('general.variables.password.sg') + ' ' + $t('general.variables.change')"
                        v-if="getUserType === userType.ADMIN" />
                    <DropdownItem @click="showDeletePaneModal(close)" icon="delete-bin" color="text-red-700"
                        :label="$t('adminMenu.pageDelete.label')" v-if="getUserType === userType.ADMIN" />
                    <Accordion :label="$t('adminMenu.copy.label')" icon="file-copy" color="text-cyan-500"
                        v-if="getUserType === userType.ADMIN">
                        <DropdownItem @click="showCopyForMeModal(close)" icon="user"
                            :label="$t('adminMenu.copy.forMe.label')" color="text-teal-500" />
                        <DropdownItem @click="showShareModal(close)" icon="group" color="text-lime-500"
                            :label="$t('adminMenu.copy.forOthers.label')" />
                    </Accordion>
                    <Accordion :label="$t('adminMenu.export.label')" icon="download" color="text-fuchsia-700">
                        <DropdownItem @click="openExportImage(close)" icon="image"
                            :label="$t('adminMenu.export.asImg.label')" color="text-blue-700" />
                        <DropdownItem @click="showPDFExportModal(close)" icon="file-pdf" color="text-red-700"
                            :label="$t('adminMenu.export.asPDF.label')" />
                    </Accordion>
                </div>
            </div>
        </template>
    </Dropdown>
</template>